// H to Pas Converter Ver.1.20.1.47 by K.Kumaki
//     Date : 14 Oct 2004
//   Source : handler.h (05 Oct 2004)

unit Easy3D;

{$X+}{$Z2}{$A8}

interface

uses Windows, Coef_v, D3DX8, Direct3D8;

//-----------------------------------------------------------------------------
//
// (c) 2002-2004 @http://www5d.biglobe.ne.jp/~ochikko
//
//-----------------------------------------------------------------------------

// Error :  #include < D3DX8.h >
// #include "Coef_v.h"

  //function InitDllFunc: HINSTANCE; cdecl;

  function E3DGetVer: PULONG; stdcall;
  function E3DSetDbgFile(hdbg: THandle): Integer; stdcall;
  function E3DCreateHandler(fname: PChar): Integer; stdcall;
  function E3DAddMotion(hsid: Integer; fname: PChar; var cookieptr: Integer; var framemaxptr: Integer): Integer; stdcall;
  function E3DSetMotionKind(hsid: Integer; motcookie: Integer): Integer; stdcall;
  function E3DSetNewPause(hsid: Integer): Integer; stdcall;
  function E3DTransform(hsid: Integer; pd3dDevice: IDIRECT3DDEVICE8; matView: TD3DMATRIX;
	 framecnt: Integer; lightflag: Integer; projmode: Integer): Integer; stdcall;
  function E3DRender(hsid: Integer; pd3dDevice: IDIRECT3DDEVICE8; withalpha: Integer): Integer; stdcall;
  function E3DRestore(hsid: Integer; pd3dDevice: IDIRECT3DDEVICE8; appwnd: HWND): Integer; stdcall;
  function E3DInvalidate(hsid: Integer): Integer; stdcall;
  function E3DDestroyHandler(hsid: Integer): Integer; stdcall;
  function E3DSetMotionStep(hsid: Integer; motcookie: Integer; step: Integer): Integer; stdcall;
  function E3DSetPosition(hsid: Integer; pos: TD3DVECTOR): Integer; stdcall;
  function E3DSetRotate(hsid: Integer; rot: TD3DVECTOR): Integer; stdcall;
  function E3DChkConflict(srchsid: Integer; chkhsid: Integer; rate1: TD3DVECTOR; 
	 rate2: TD3DVECTOR; var inviewflag: Integer): Integer; stdcall;
  function E3DCreateAfterImage(hsid: Integer; pd3dDevice: IDIRECT3DDEVICE8; imagenum: Integer): Integer; stdcall;
  function E3DDestroyAfterImage(hsid: Integer): Integer; stdcall;
  function E3DSetAlpha(hsid: Integer; alpha: Single): Integer; stdcall;
//extern int (__stdcall * E3DSeIDIRECTionalLight)( int hsid, TD3DVECTOR dir );
  function E3DGetBoundaryBox(hsid: Integer; var dstptr: Single): Integer; stdcall;

  function E3DCreateLight(var lightIDptr: Integer): Integer; stdcall;
  function E3DDestroyLight(lightID: Integer; pd3dDevice: IDIRECT3DDEVICE8): Integer; stdcall;
  function E3DSetDirectionalLight(lid: Integer; dir: TD3DVECTOR; col: TD3DVECTOR; 
	 pd3dDevice: IDIRECT3DDEVICE8): Integer; stdcall;
  function E3DSetPointLight(lid: Integer; pos: TD3DVECTOR; dist: Single; col: TD3DVECTOR; 
	 pd3dDevice: IDIRECT3DDEVICE8): Integer; stdcall;
  function E3DSetSpotLight(lid: Integer; pos: TD3DVECTOR; dir: TD3DVECTOR; dist: Single; 
	 angledeg: Single; col: TD3DVECTOR; pd3dDevice: IDIRECT3DDEVICE8): Integer; stdcall;

  function E3DChkInView(hsid: Integer; viewpos: TD3DVECTOR; viewtarget: TD3DVECTOR): Integer; stdcall;
  function E3DChkConfBySphere(srchsid: Integer; chkhsid: Integer; conflevel: Integer; 
	 var resultptr: Integer): Integer; stdcall;

  function E3DInit(apphwnd: HWND; hinst: Integer; comflag: Integer): Integer; stdcall;
  function E3DBye(comflag: Integer): Integer; stdcall;
  function E3DCreateProgressBar: Integer; stdcall;
  function E3DSetProgressBar(newpos: Integer): Integer; stdcall;
  function E3DDestroyProgressBar: Integer; stdcall;

  function E3DSetProjection(nearplane: Single; farplane: Single; degfov: Single): Integer; stdcall;
  function E3DLoadGroundBMP(bmpname1: PChar; bmpname2: PChar; bmpname3: PChar; 
	 texturename: PChar; maxx: Single; maxz: Single; divx: Integer; divz: Integer; 
	 maxheight: Single): Integer; stdcall;


  function E3DSetBeforePos(hsid: Integer): Integer; stdcall;
  function E3DChkConfGround(charahsid: Integer; groundhsid: Integer; mode: Integer; 
	 diffmaxy: Single; mapminy: Single; var resultptr: Integer; var adjustv: TD3DVECTOR; 
	 var nv: TD3DVECTOR): Integer; stdcall;
  function E3DChkConfGround2(befpos: TD3DVECTOR; newpos: TD3DVECTOR; groundhsid: Integer; 
	 mode: Integer; diffmaxy: Single; mapminy: Single; var resultptr: Integer; var adjustv: TD3DVECTOR; 
	 var nv: TD3DVECTOR): Integer; stdcall;

  function E3DGetPartNoByName(hsid: Integer; partname: PChar; var partnoptr: Integer): Integer; stdcall;
  function E3DGetVertNumOfPart(hsid: Integer; partno: Integer; var vertnumptr: Integer): Integer; stdcall;
  function E3DGetVertPos(hsid: Integer; partno: Integer; vertno: Integer; var vertptr: TD3DVECTOR): Integer; stdcall;
  function E3DSetVertPos(hsid: Integer; partno: Integer; vertno: Integer; srcvert: TD3DVECTOR): Integer; stdcall;
  function E3DSetPosOnGround(hsid: Integer; groundhsid: Integer; mapmaxy: Single; 
	 mapminy: Single; posx: Single; posz: Single): Integer; stdcall;

  function E3DCreateBillboard(bmpname: PChar; width: Single; height: Single; transparentflag: Integer; 
	 var billboardidptr: Integer): Integer; stdcall;
  function E3DRenderBillboard(pdev: IDIRECT3DDEVICE8; camerapos: TD3DVECTOR; 
	 cameratarget: TD3DVECTOR; matView: TD3DMATRIX): Integer; stdcall;
  function E3DSetBillboardPos(billboardid: Integer; srcpos: TD3DVECTOR): Integer; stdcall;
  function E3DSetBillboardOnGround(billboardid: Integer; groundid: Integer; mapmaxy: Single; 
	 mapminy: Single; posx: Single; posz: Single): Integer; stdcall;
  function E3DDestroyBillboard(billboardid: Integer): Integer; stdcall;
  function E3DChkConfBillboard(hsid: Integer; confrate: Single; var resultptr: Integer): Integer; stdcall;
  function E3DChkConfBillboard2(srccenter: TD3DVECTOR; srcr: Single; confrate: Single; 
	 var resultptr: Integer): Integer; stdcall;
  function E3DInvalidateBillboard: Integer; stdcall;
  function E3DRestoreBillboard(pdev: IDIRECT3DDEVICE8; appwnd: HWND): Integer; stdcall;

  function E3DDestroyAllBillboard: Integer; stdcall;
  function E3DCreateBG(pdev: IDIRECT3DDEVICE8; name1: PChar; name2: PChar; uanime: Single; 
	 vanime: Single; isround: Integer): Integer; stdcall;
  function E3DRenderBG(pdev: IDIRECT3DDEVICE8; appwnd: HWND; matView: TD3DMATRIX): Integer; stdcall;
  function E3DDestroyBG: Integer; stdcall;

  function E3DSaveMQOFile(groundid: Integer; filename: PChar; apphwnd: HWND): Integer; stdcall;
  function E3DLoadMQOFileAsGround(filename: PChar; mult: Single; apphwnd: HWND): Integer; stdcall;

  function E3DGetBillboardNum(var bbnumptr: Integer): Integer; stdcall;
  function E3DGetAllBillboardInfo(getnum: Integer; var bbnoptr: Integer; var bbposptr: TD3DVECTOR; 
	 var texnameptr: PChar; var transparentptr: Integer; var widthptr: Single; var heightptr: Single): Integer; stdcall;

  function E3DGetInvisibleFlag(hsid: Integer; partno: Integer; var dstflag: Integer): Integer; stdcall;
  function E3DSetInvisibleFlag(hsid: Integer; partno: Integer; srcflag: Integer): Integer; stdcall;
  function E3DGetNearBillboard(srcpos: TD3DVECTOR; maxdist: Single; var nearbbid: Integer): Integer; stdcall;

  function E3DSetMovableArea(bmpname: PChar; maxx: Single; maxz: Single; divx: Integer; 
	 divz: Integer; wallheight: Single): Integer; stdcall;
  function E3DChkConfWall(charahsid: Integer; groundhsid: Integer; dist: Single; 
	 var resultptr: Integer; var adjustv: TD3DVECTOR; var nv: TD3DVECTOR): Integer; stdcall;
  function E3DChkConfWall2(befpos: TD3DVECTOR; newpos: TD3DVECTOR; groundhsid: Integer; 
	 dist: Single; var resultptr: Integer; var adjustv: TD3DVECTOR; var nv: TD3DVECTOR): Integer; stdcall;
  function E3DLoadMQOFileAsMovableArea(filename: PChar; mult: Single; apphwnd: HWND): Integer; stdcall;


  function E3DLoadSound(filename: PChar): Integer; stdcall;
  function E3DPlaySound(soundid: Integer; isprimary: Integer): Integer; stdcall;
  function E3DStopSound(soundid: Integer): Integer; stdcall;
  function E3DSetSoundLoop(soundid: Integer; loopflag: Integer): Integer; stdcall;
  function E3DSetSoundVolume(volume: Integer): Integer; stdcall;
  function E3DSetSoundTempo(tempo: Single): Integer; stdcall;


  function E3DCreateNaviLine: Integer; stdcall;
  function E3DDestroyNaviLine(lineid: Integer): Integer; stdcall;
  function E3DAddNaviPoint(lineid: Integer; befpointid: Integer; var pointid: Integer): Integer; stdcall;	// befpointid̎Ƀ`FCBbef==-1̂ƂŌɁAbef==-2̂ƂŏɃ`FC
  function E3DRemoveNaviPoint(lineid: Integer; pointid: Integer): Integer; stdcall;
  function E3DGetNaviPointPos(lineid: Integer; pointid: Integer; var pos: TD3DVECTOR): Integer; stdcall;	// lineid, pointid w肵āApoint̍W擾B
  function E3DSetNaviPointPos(lineid: Integer; pointid: Integer; srcpos: TD3DVECTOR): Integer; stdcall;
  function E3DGetNaviPointOwnerID(lineid: Integer; pointid: Integer; var ownerid: Integer): Integer; stdcall;
  function E3DSetNaviPointOwnerID(lineid: Integer; pointid: Integer; ownerid: Integer): Integer; stdcall;
  function E3DGetNextNaviPoint(lineid: Integer; pointid: Integer; var nextid: Integer): Integer; stdcall;	//pointid next `FCpointidԂBpointid == -1 ̂ƂA擪pointԂ
  function E3DGetPrevNaviPoint(lineid: Integer; pointid: Integer; var befid: Integer): Integer; stdcall;	// nextid == -1̂Ƃ́AnextȂAbefid == -1̂Ƃ́AbefȂ
  function E3DGetNearestNaviPoint(lineid: Integer; srcpos: TD3DVECTOR; var nearid: Integer; 
	 var previd: Integer; var nextid: Integer): Integer; stdcall;	// ԋ߂NaviPointƁȂONaviPointpointid擾
  function E3DFillUpNaviLine(lineid: Integer; div0: Integer; flag: Integer): Integer; stdcall;	// 3ȏ_ȂƂ́AȂBpointid tւ邩ǂ̃tOHH
  function E3DSetNaviLineOnGround(lineid: Integer; groundid: Integer; mapmaxy: Single; 
	 mapminy: Single): Integer; stdcall;	//SĂnavipointnʂ̍ɃZbgB

  function E3DControlByNaviLine(hsid: Integer; lineid: Integer; ctrlmode: Integer; 
	 roundflag: Integer; reverseflag: Integer; maxdist: Single; posstep: Single; dirstep: Single; 
	 var newpos: TD3DVECTOR; var newqx: Single; var newqy: Single; var newqz: Single; 
	 var newqw: Single; var tpidptr: Integer): Integer; stdcall;
  function E3DSetDirQ(hsid: Integer; qx: Single; qy: Single; qz: Single; qw: Single): Integer; stdcall;
  function E3DGetDirQ(hsid: Integer; var qxptr: Single; var qyptr: Single; var qzptr: Single; 
	 var qwptr: Single): Integer; stdcall;
  function E3DCreateNaviPointClearFlag(hsid: Integer; lineno: Integer; roundnum: Integer): Integer; stdcall;
  function E3DDestroyNaviPointClearFlag(hsid: Integer): Integer; stdcall;
  function E3DInitNaviPointClearFlag(hsid: Integer): Integer; stdcall;
  function E3DSetNaviPointClearFlag(hsid: Integer; srcpos: TD3DVECTOR; maxdist: Single; 
	 var npidptr: Integer; var roundptr: Integer; var distptr: Single): Integer; stdcall;
  function E3DGetOrder(var hsidptr: Integer; arrayleng: Integer; var orderptr: Integer; 
	 var clearnoptr: Integer): Integer; stdcall;
  function E3DGetPosition(hsid: Integer; var pos: TD3DVECTOR): Integer; stdcall;


  function E3DSetTexture(hsid: Integer; partno: Integer; texname: PChar; pd3dDevice: IDIRECT3DDEVICE8; 
	 apphwnd: HWND): Integer; stdcall;
  function E3DReorderNaviPoint(lineid: Integer; var oldnoptr: Integer; ptrlen: Integer; 
	 var setlenptr: Integer): Integer; stdcall;


  function E3DSetAlpha2(hsid: Integer; alpha: Single; partno: Integer): Integer; stdcall;
  function E3DSetValidFlag(hsid: Integer; partno: Integer; flag: Integer): Integer; stdcall;
  function E3DSetDiffuse(hsid: Integer; partno: Integer; r: Integer; g: Integer; 
	 b: Integer; setflag: Integer; vertno: Integer): Integer; stdcall;
  function E3DSetSpecular(hsid: Integer; partno: Integer; r: Integer; g: Integer; 
	 b: Integer; setflag: Integer; vertno: Integer): Integer; stdcall;
  function E3DSetAmbient(hsid: Integer; partno: Integer; r: Integer; g: Integer; 
	 b: Integer; setflag: Integer; vertno: Integer): Integer; stdcall;
  function E3DSetBlendingMode(hsid: Integer; partno: Integer; bmode: Integer): Integer; stdcall;
  function E3DSetRenderState(hsid: Integer; partno: Integer; statetype: Integer; 
	 value: Integer): Integer; stdcall;
  function E3DSetScale(hsid: Integer; partno: Integer; scalevec: TD3DVECTOR; centerflag: Integer): Integer; stdcall;



  function E3DGetScreenPos(hsid: Integer; partno: Integer; var scpos2: TD3DXVECTOR2;
	 matView: TD3DMATRIX; vertno: Integer; calcmode: Integer): Integer; stdcall;
  function E3DCreateQ(var qidptr: Integer): Integer; stdcall;
  function E3DDestroyQ(qid: Integer): Integer; stdcall;
  function E3DInitQ(qid: Integer): Integer; stdcall;
  function E3DRotateQX(qid: Integer; degx: Single): Integer; stdcall;
  function E3DRotateQY(qid: Integer; degy: Single): Integer; stdcall;
  function E3DRotateQZ(qid: Integer; degz: Single): Integer; stdcall;
  function E3DMultQ(resultqid: Integer; befqid: Integer; aftqid: Integer): Integer; stdcall;
  function E3DSetQAxisAndDeg(qid: Integer; axis: TD3DVECTOR; deg: Single): Integer; stdcall;
  function E3DGetQAxisAndDeg(qid: Integer; var axisptr: TD3DVECTOR; var degptr: Single): Integer; stdcall;
  function E3DNormalizeQ(qid: Integer): Integer; stdcall;
  function E3DCopyQ(dstqid: Integer; srcqid: Integer): Integer; stdcall;


  function E3DGetBoneNoByName(hsid: Integer; name: PChar; var bonenoptr: Integer): Integer; stdcall;
  function E3DGetNextMP(hsid: Integer; motionid: Integer; boneno: Integer; prevmpid: Integer; 
	 var mpidptr: Integer): Integer; stdcall;
  function E3DGetMPInfo(hsid: Integer; motionid: Integer; boneno: Integer; mpid: Integer; 
	 var infoptr: MPINFO): Integer; stdcall;
  function E3DSetMPInfo(hsid: Integer; motionid: Integer; boneno: Integer; mpid: Integer; 
	 var infoptr: MPINFO; var infoflagptr: Integer): Integer; stdcall;
  function E3DIsExistMP(hsid: Integer; motionid: Integer; boneno: Integer; frameno: Integer; 
	 var mpidptr: Integer): Integer; stdcall;
  function E3DGetMotionFrameLength(hsid: Integer; motionid: Integer; var framelengptr: Integer): Integer; stdcall;
  function E3DSetMotionFrameLength(hsid: Integer; motionid: Integer; frameleng: Integer; 
	 initflag: Integer): Integer; stdcall;
  function E3DAddMP(hsid: Integer; motionid: Integer; boneno: Integer; var infoptr: MPINFO; 
	 var mpidptr: Integer): Integer; stdcall;
  function E3DDeleteMP(hsid: Integer; motionid: Integer; boneno: Integer; mpid: Integer): Integer; stdcall;
  function E3DFillUpMotion(hsid: Integer; motionid: Integer; boneno: Integer; startframe: Integer; 
	 endframe: Integer; initflag: Integer): Integer; stdcall;
  function E3DCopyMotionFrame(hsid: Integer; srcmotid: Integer; srcframeno: Integer; 
	 dstmotid: Integer; dstframeno: Integer): Integer; stdcall;
  function E3DGetDirQ2(hsid: Integer; qid: Integer): Integer; stdcall;
  function E3DSetDirQ2(hsid: Integer; qid: Integer): Integer; stdcall;

  function E3DLookAtQ(qid: Integer; vec: TD3DVECTOR; basevec: TD3DVECTOR; upflag: Integer; 
	 divnum: Integer): Integer; stdcall;
  function E3DTwistQ(qid: Integer; twistdeg: Single; basevec: TD3DVECTOR): Integer; stdcall;
  function E3DInitTwistQ(qid: Integer; basevec: TD3DVECTOR): Integer; stdcall;
  function E3DGetTwistQ(qid: Integer; var twistptr: Single): Integer; stdcall;
  function E3DMultQVec(qid: Integer; befvec: TD3DVECTOR; var aftvecptr: TD3DVECTOR): Integer; stdcall;
  function E3DRotateQLocalX(qid: Integer; deg: Single): Integer; stdcall;
  function E3DRotateQLocalY(qid: Integer; deg: Single): Integer; stdcall;
  function E3DRotateQLocalZ(qid: Integer; deg: Single): Integer; stdcall;
  function E3DGetBonePos(hsid: Integer; boneno: Integer; poskind: Integer; motid: Integer; 
	 frameno: Integer; var posptr: TD3DVECTOR): Integer; stdcall;

  function E3DSetMotionFrameNo(hsid: Integer; mk: Integer; srcframeno: Integer): Integer; stdcall;
  function E3DWaitByFPS(srcfps: Integer): Integer; stdcall;


  function E3DCreateLine(var pointarray: TD3DVECTOR; pointnum: Integer; maxpointnum: Integer; 
	 linekind: Integer; var lineidptr: Integer): Integer; stdcall;
  function E3DDestroyLine(lineid: Integer): Integer; stdcall;
  function E3DSetLineColor(lineid: Integer; argb: D3DCOLOR): Integer; stdcall;
  function E3DAddPoint2Line(lineid: Integer; prevpid: Integer; var newpidptr: Integer): Integer; stdcall;
  function E3DDeletePointOfLine(lineid: Integer; pid: Integer): Integer; stdcall;
  function E3DSetPointPosOfLine(lineid: Integer; pid: Integer; pos: TD3DVECTOR): Integer; stdcall;
  function E3DGetPointPosOfLine(lineid: Integer; pid: Integer; var posptr: TD3DVECTOR): Integer; stdcall;
  function E3DGetNextPointOfLine(lineid: Integer; prevpid: Integer; var nextpidptr: Integer): Integer; stdcall;
  function E3DGetPrevPointOfLine(lineid: Integer; pid: Integer; var prevpidptr: Integer): Integer; stdcall;


  function E3DWriteDisplay2BMP(bmpname: PChar; pdev: IDIRECT3DDEVICE8): Integer; stdcall;
  function E3DCreateAVIFile(filename: PChar; datatype: Integer; compkind: Integer; 
	 framerate: Integer; frameleng: Integer; pdev: IDIRECT3DDEVICE8; var aviidptr: Integer): Integer; stdcall;
  function E3DWriteData2AVIFile(aviid: Integer; datatype: Integer; pdev: IDIRECT3DDEVICE8): Integer; stdcall;
  function E3DCompleteAVIFile(aviid: Integer; datatype: Integer; pdev: IDIRECT3DDEVICE8): Integer; stdcall;



  function E3DCameraLookAt(srcvec: TD3DVECTOR; upflag: Integer; divnum: Integer; 
	 newcampos: TD3DVECTOR; srcvmat: TD3DMATRIX; var newtargetpos: TD3DVECTOR; var newupvec: TD3DVECTOR): Integer; stdcall;
  function E3DCameraOnNaviLine(nlid: Integer; mode: Integer; roundflag: Integer; 
	 reverseflag: Integer; offset: TD3DVECTOR; posstep: Single; dirdivnum: Integer; 
	 upflag: Integer; srcvmat: TD3DMATRIX; var newcampos: TD3DVECTOR; var newtargetpos: TD3DVECTOR; 
	 var newupvec: TD3DVECTOR; var tpidptr: Integer): Integer; stdcall;
  function E3DCameraDirUp(deg: Single; divnum: Integer; srcvmat: TD3DMATRIX; newcampos: TD3DVECTOR; 
	 var newtargetpos: TD3DVECTOR; var newupvec: TD3DVECTOR): Integer; stdcall;
  function E3DCameraDirDown(deg: Single; divnum: Integer; srcvmat: TD3DMATRIX; 
	 newcampos: TD3DVECTOR; var newtargetpos: TD3DVECTOR; var newupvec: TD3DVECTOR): Integer; stdcall;
  function E3DCameraDirRight(deg: Single; divnum: Integer; srcvmat: TD3DMATRIX; 
	 newcampos: TD3DVECTOR; var newtargetpos: TD3DVECTOR; var newupvec: TD3DVECTOR): Integer; stdcall;
  function E3DCameraDirLeft(deg: Single; divnum: Integer; srcvmat: TD3DMATRIX; 
	 newcampos: TD3DVECTOR; var newtargetpos: TD3DVECTOR; var newupvec: TD3DVECTOR): Integer; stdcall;

  function E3DLoadBIMFile(hsid: Integer; bimfilename: PChar): Integer; stdcall;

  function E3DCreateFont(pdev: IDIRECT3DDEVICE8; height: Integer; width: Integer;
	 weight: Integer; bItalic: Integer; bUnderline: Integer; bStrikeout: Integer; 
	 fontname: PChar; var fontidptr: Integer): Integer; stdcall;
  function E3DDrawTextByFontID(apphwnd: HWND; fontid: Integer; posx: Integer; posy: Integer; 
	 textstr: PChar; col: D3DCOLOR): Integer; stdcall;
  function E3DDestroyFont(fontid: Integer): Integer; stdcall;



  function E3DSlerpQ(startqid: Integer; endqid: Integer; t: Single; resqid: Integer): Integer; stdcall;
  function E3DSquadQ(befqid: Integer; startqid: Integer; endqid: Integer; aftqid: Integer; 
	 t: Single; resqid: Integer): Integer; stdcall;
  function E3DSplineVec(pos0: TD3DVECTOR; pos1: TD3DVECTOR; pos2: TD3DVECTOR; 
	 pos3: TD3DVECTOR; t: Single; var respos: TD3DVECTOR): Integer; stdcall;
  function E3DGetDiffuse(hsid: Integer; partno: Integer; vertno: Integer; var rptr: Integer; 
	 var gptr: Integer; var bptr: Integer): Integer; stdcall;
  function E3DGetSpecular(hsid: Integer; partno: Integer; vertno: Integer; var rptr: Integer; 
	 var gptr: Integer; var bptr: Integer): Integer; stdcall;
  function E3DGetAmbient(hsid: Integer; partno: Integer; vertno: Integer; var rptr: Integer; 
	 var gptr: Integer; var bptr: Integer): Integer; stdcall;
  function E3DGetAlpha(hsid: Integer; partno: Integer; vertno: Integer; var aptr: Integer): Integer; stdcall;
  function E3DSaveSigFile(hsid: Integer; filename: PChar): Integer; stdcall;
  function E3DSetMipMapParams(miplevels: UINT; mipfilter: DWORD): Integer; stdcall;
  function E3DPickVert(hsid: Integer; posx: Integer; posy: Integer; rangex: Integer; 
	 rangey: Integer; var pickpartarray: Integer; var pickvertarray: Integer; arrayleng: Integer; 
	 var getnum: Integer): Integer; stdcall;
  function E3DGetCullingFlag(hsid: Integer; partno: Integer; vertno: Integer; var viewcullptr: Integer; 
	 var revcullptr: Integer): Integer; stdcall;
  function E3DGetOrgVertNo(hsid: Integer; partno: Integer; vertno: Integer; var orgnoarray: Integer; 
	 arrayleng: Integer; var getnumptr: Integer): Integer; stdcall;


  function E3DLoadIM2File(hsid: Integer; im2filename: PChar): Integer; stdcall;
  function E3DSaveIM2File(hsid: Integer; im2filename: PChar): Integer; stdcall;
  function E3DChkIM2Status(hsid: Integer; var statusptr: Integer): Integer; stdcall;

  function E3DGetScreenPos2(matView: TD3DMATRIX; vec3d: TD3DVECTOR; var vec2d: TD3DXVECTOR2;
	 var validflag: Integer): Integer; stdcall;


implementation

const
  Easy3ddll = 'Easy3d.dll';

  function E3DGetVer; external Easy3ddll name 'E3DGetVer';
  function E3DSetDbgFile; external Easy3ddll name 'E3DSetDbgFile';
  function E3DCreateHandler; external Easy3ddll name 'E3DCreateHandler';
  function E3DAddMotion; external Easy3ddll name 'E3DAddMotion';
  function E3DSetMotionKind; external Easy3ddll name 'E3DSetMotionKind';
  function E3DSetNewPause; external Easy3ddll name 'E3DSetNewPause';
  function E3DTransform; external Easy3ddll name 'E3DTransform';
  function E3DRender; external Easy3ddll name 'E3DRender';
  function E3DRestore; external Easy3ddll name 'E3DRestore';
  function E3DInvalidate; external Easy3ddll name 'E3DInvalidate';
  function E3DDestroyHandler; external Easy3ddll name 'E3DDestroyHandler';
  function E3DSetMotionStep; external Easy3ddll name 'E3DSetMotionStep';
  function E3DSetPosition; external Easy3ddll name 'E3DSetPosition';
  function E3DSetRotate; external Easy3ddll name 'E3DSetRotate';
  function E3DChkConflict; external Easy3ddll name 'E3DChkConflict';
  function E3DCreateAfterImage; external Easy3ddll name 'E3DCreateAfterImage';
  function E3DDestroyAfterImage; external Easy3ddll name 'E3DDestroyAfterImage';
  function E3DSetAlpha; external Easy3ddll name 'E3DSetAlpha';
  function E3DGetBoundaryBox; external Easy3ddll name 'E3DGetBoundaryBox';
  function E3DCreateLight; external Easy3ddll name 'E3DCreateLight';
  function E3DDestroyLight; external Easy3ddll name 'E3DDestroyLight';
  function E3DSetDirectionalLight; external Easy3ddll name 'E3DSetDirectionalLight';
  function E3DSetPointLight; external Easy3ddll name 'E3DSetPointLight';
  function E3DSetSpotLight; external Easy3ddll name 'E3DSetSpotLight';
  function E3DChkInView; external Easy3ddll name 'E3DChkInView';
  function E3DChkConfBySphere; external Easy3ddll name 'E3DChkConfBySphere';
  function E3DInit; external Easy3ddll name 'E3DInit';
  function E3DBye; external Easy3ddll name 'E3DBye';
  function E3DCreateProgressBar; external Easy3ddll name 'E3DCreateProgressBar';
  function E3DSetProgressBar; external Easy3ddll name 'E3DSetProgressBar';
  function E3DDestroyProgressBar; external Easy3ddll name 'E3DDestroyProgressBar';
  function E3DSetProjection; external Easy3ddll name 'E3DSetProjection';
  function E3DLoadGroundBMP; external Easy3ddll name 'E3DLoadGroundBMP';
  function E3DSetBeforePos; external Easy3ddll name 'E3DSetBeforePos';
  function E3DChkConfGround; external Easy3ddll name 'E3DChkConfGround';
  function E3DChkConfGround2; external Easy3ddll name 'E3DChkConfGround2';
  function E3DGetPartNoByName; external Easy3ddll name 'E3DGetPartNoByName';
  function E3DGetVertNumOfPart; external Easy3ddll name 'E3DGetVertNumOfPart';
  function E3DGetVertPos; external Easy3ddll name 'E3DGetVertPos';
  function E3DSetVertPos; external Easy3ddll name 'E3DSetVertPos';
  function E3DSetPosOnGround; external Easy3ddll name 'E3DSetPosOnGround';
  function E3DCreateBillboard; external Easy3ddll name 'E3DCreateBillboard';
  function E3DRenderBillboard; external Easy3ddll name 'E3DRenderBillboard';
  function E3DSetBillboardPos; external Easy3ddll name 'E3DSetBillboardPos';
  function E3DSetBillboardOnGround; external Easy3ddll name 'E3DSetBillboardOnGround';
  function E3DDestroyBillboard; external Easy3ddll name 'E3DDestroyBillboard';
  function E3DChkConfBillboard; external Easy3ddll name 'E3DChkConfBillboard';
  function E3DChkConfBillboard2; external Easy3ddll name 'E3DChkConfBillboard2';
  function E3DInvalidateBillboard; external Easy3ddll name 'E3DInvalidateBillboard';
  function E3DRestoreBillboard; external Easy3ddll name 'E3DRestoreBillboard';
  function E3DDestroyAllBillboard; external Easy3ddll name 'E3DDestroyAllBillboard';
  function E3DCreateBG; external Easy3ddll name 'E3DCreateBG';
  function E3DRenderBG; external Easy3ddll name 'E3DRenderBG';
  function E3DDestroyBG; external Easy3ddll name 'E3DDestroyBG';
  function E3DSaveMQOFile; external Easy3ddll name 'E3DSaveMQOFile';
  function E3DLoadMQOFileAsGround; external Easy3ddll name 'E3DLoadMQOFileAsGround';
  function E3DGetBillboardNum; external Easy3ddll name 'E3DGetBillboardNum';
  function E3DGetAllBillboardInfo; external Easy3ddll name 'E3DGetAllBillboardInfo';
  function E3DGetInvisibleFlag; external Easy3ddll name 'E3DGetInvisibleFlag';
  function E3DSetInvisibleFlag; external Easy3ddll name 'E3DSetInvisibleFlag';
  function E3DGetNearBillboard; external Easy3ddll name 'E3DGetNearBillboard';
  function E3DSetMovableArea; external Easy3ddll name 'E3DSetMovableArea';
  function E3DChkConfWall; external Easy3ddll name 'E3DChkConfWall';
  function E3DChkConfWall2; external Easy3ddll name 'E3DChkConfWall2';
  function E3DLoadMQOFileAsMovableArea; external Easy3ddll name 'E3DLoadMQOFileAsMovableArea';
  function E3DLoadSound; external Easy3ddll name 'E3DLoadSound';
  function E3DPlaySound; external Easy3ddll name 'E3DPlaySound';
  function E3DStopSound; external Easy3ddll name 'E3DStopSound';
  function E3DSetSoundLoop; external Easy3ddll name 'E3DSetSoundLoop';
  function E3DSetSoundVolume; external Easy3ddll name 'E3DSetSoundVolume';
  function E3DSetSoundTempo; external Easy3ddll name 'E3DSetSoundTempo';
  function E3DCreateNaviLine; external Easy3ddll name 'E3DCreateNaviLine';
  function E3DDestroyNaviLine; external Easy3ddll name 'E3DDestroyNaviLine';
  function E3DAddNaviPoint; external Easy3ddll name 'E3DAddNaviPoint';
  function E3DRemoveNaviPoint; external Easy3ddll name 'E3DRemoveNaviPoint';
  function E3DGetNaviPointPos; external Easy3ddll name 'E3DGetNaviPointPos';
  function E3DSetNaviPointPos; external Easy3ddll name 'E3DSetNaviPointPos';
  function E3DGetNaviPointOwnerID; external Easy3ddll name 'E3DGetNaviPointOwnerID';
  function E3DSetNaviPointOwnerID; external Easy3ddll name 'E3DSetNaviPointOwnerID';
  function E3DGetNextNaviPoint; external Easy3ddll name 'E3DGetNextNaviPoint';
  function E3DGetPrevNaviPoint; external Easy3ddll name 'E3DGetPrevNaviPoint';
  function E3DGetNearestNaviPoint; external Easy3ddll name 'E3DGetNearestNaviPoint';
  function E3DFillUpNaviLine; external Easy3ddll name 'E3DFillUpNaviLine';
  function E3DSetNaviLineOnGround; external Easy3ddll name 'E3DSetNaviLineOnGround';
  function E3DControlByNaviLine; external Easy3ddll name 'E3DControlByNaviLine';
  function E3DSetDirQ; external Easy3ddll name 'E3DSetDirQ';
  function E3DGetDirQ; external Easy3ddll name 'E3DGetDirQ';
  function E3DCreateNaviPointClearFlag; external Easy3ddll name 'E3DCreateNaviPointClearFlag';
  function E3DDestroyNaviPointClearFlag; external Easy3ddll name 'E3DDestroyNaviPointClearFlag';
  function E3DInitNaviPointClearFlag; external Easy3ddll name 'E3DInitNaviPointClearFlag';
  function E3DSetNaviPointClearFlag; external Easy3ddll name 'E3DSetNaviPointClearFlag';
  function E3DGetOrder; external Easy3ddll name 'E3DGetOrder';
  function E3DGetPosition; external Easy3ddll name 'E3DGetPosition';
  function E3DSetTexture; external Easy3ddll name 'E3DSetTexture';
  function E3DReorderNaviPoint; external Easy3ddll name 'E3DReorderNaviPoint';
  function E3DSetAlpha2; external Easy3ddll name 'E3DSetAlpha2';
  function E3DSetValidFlag; external Easy3ddll name 'E3DSetValidFlag';
  function E3DSetDiffuse; external Easy3ddll name 'E3DSetDiffuse';
  function E3DSetSpecular; external Easy3ddll name 'E3DSetSpecular';
  function E3DSetAmbient; external Easy3ddll name 'E3DSetAmbient';
  function E3DSetBlendingMode; external Easy3ddll name 'E3DSetBlendingMode';
  function E3DSetRenderState; external Easy3ddll name 'E3DSetRenderState';
  function E3DSetScale; external Easy3ddll name 'E3DSetScale';
  function E3DGetScreenPos; external Easy3ddll name 'E3DGetScreenPos';
  function E3DCreateQ; external Easy3ddll name 'E3DCreateQ';
  function E3DDestroyQ; external Easy3ddll name 'E3DDestroyQ';
  function E3DInitQ; external Easy3ddll name 'E3DInitQ';
  function E3DRotateQX; external Easy3ddll name 'E3DRotateQX';
  function E3DRotateQY; external Easy3ddll name 'E3DRotateQY';
  function E3DRotateQZ; external Easy3ddll name 'E3DRotateQZ';
  function E3DMultQ; external Easy3ddll name 'E3DMultQ';
  function E3DSetQAxisAndDeg; external Easy3ddll name 'E3DSetQAxisAndDeg';
  function E3DGetQAxisAndDeg; external Easy3ddll name 'E3DGetQAxisAndDeg';
  function E3DNormalizeQ; external Easy3ddll name 'E3DNormalizeQ';
  function E3DCopyQ; external Easy3ddll name 'E3DCopyQ';
  function E3DGetBoneNoByName; external Easy3ddll name 'E3DGetBoneNoByName';
  function E3DGetNextMP; external Easy3ddll name 'E3DGetNextMP';
  function E3DGetMPInfo; external Easy3ddll name 'E3DGetMPInfo';
  function E3DSetMPInfo; external Easy3ddll name 'E3DSetMPInfo';
  function E3DIsExistMP; external Easy3ddll name 'E3DIsExistMP';
  function E3DGetMotionFrameLength; external Easy3ddll name 'E3DGetMotionFrameLength';
  function E3DSetMotionFrameLength; external Easy3ddll name 'E3DSetMotionFrameLength';
  function E3DAddMP; external Easy3ddll name 'E3DAddMP';
  function E3DDeleteMP; external Easy3ddll name 'E3DDeleteMP';
  function E3DFillUpMotion; external Easy3ddll name 'E3DFillUpMotion';
  function E3DCopyMotionFrame; external Easy3ddll name 'E3DCopyMotionFrame';
  function E3DGetDirQ2; external Easy3ddll name 'E3DGetDirQ2';
  function E3DSetDirQ2; external Easy3ddll name 'E3DSetDirQ2';
  function E3DLookAtQ; external Easy3ddll name 'E3DLookAtQ';
  function E3DTwistQ; external Easy3ddll name 'E3DTwistQ';
  function E3DInitTwistQ; external Easy3ddll name 'E3DInitTwistQ';
  function E3DGetTwistQ; external Easy3ddll name 'E3DGetTwistQ';
  function E3DMultQVec; external Easy3ddll name 'E3DMultQVec';
  function E3DRotateQLocalX; external Easy3ddll name 'E3DRotateQLocalX';
  function E3DRotateQLocalY; external Easy3ddll name 'E3DRotateQLocalY';
  function E3DRotateQLocalZ; external Easy3ddll name 'E3DRotateQLocalZ';
  function E3DGetBonePos; external Easy3ddll name 'E3DGetBonePos';
  function E3DSetMotionFrameNo; external Easy3ddll name 'E3DSetMotionFrameNo';
  function E3DWaitByFPS; external Easy3ddll name 'E3DWaitByFPS';
  function E3DCreateLine; external Easy3ddll name 'E3DCreateLine';
  function E3DDestroyLine; external Easy3ddll name 'E3DDestroyLine';
  function E3DSetLineColor; external Easy3ddll name 'E3DSetLineColor';
  function E3DAddPoint2Line; external Easy3ddll name 'E3DAddPoint2Line';
  function E3DDeletePointOfLine; external Easy3ddll name 'E3DDeletePointOfLine';
  function E3DSetPointPosOfLine; external Easy3ddll name 'E3DSetPointPosOfLine';
  function E3DGetPointPosOfLine; external Easy3ddll name 'E3DGetPointPosOfLine';
  function E3DGetNextPointOfLine; external Easy3ddll name 'E3DGetNextPointOfLine';
  function E3DGetPrevPointOfLine; external Easy3ddll name 'E3DGetPrevPointOfLine';
  function E3DWriteDisplay2BMP; external Easy3ddll name 'E3DWriteDisplay2BMP';
  function E3DCreateAVIFile; external Easy3ddll name 'E3DCreateAVIFile';
  function E3DWriteData2AVIFile; external Easy3ddll name 'E3DWriteData2AVIFile';
  function E3DCompleteAVIFile; external Easy3ddll name 'E3DCompleteAVIFile';
  function E3DCameraLookAt; external Easy3ddll name 'E3DCameraLookAt';
  function E3DCameraOnNaviLine; external Easy3ddll name 'E3DCameraOnNaviLine';
  function E3DCameraDirUp; external Easy3ddll name 'E3DCameraDirUp';
  function E3DCameraDirDown; external Easy3ddll name 'E3DCameraDirDown';
  function E3DCameraDirRight; external Easy3ddll name 'E3DCameraDirRight';
  function E3DCameraDirLeft; external Easy3ddll name 'E3DCameraDirLeft';
  function E3DLoadBIMFile; external Easy3ddll name 'E3DLoadBIMFile';
  function E3DCreateFont; external Easy3ddll name 'E3DCreateFont';
  function E3DDrawTextByFontID; external Easy3ddll name 'E3DDrawTextByFontID';
  function E3DDestroyFont; external Easy3ddll name 'E3DDestroyFont';
  function E3DSlerpQ; external Easy3ddll name 'E3DSlerpQ';
  function E3DSquadQ; external Easy3ddll name 'E3DSquadQ';
  function E3DSplineVec; external Easy3ddll name 'E3DSplineVec';
  function E3DGetDiffuse; external Easy3ddll name 'E3DGetDiffuse';
  function E3DGetSpecular; external Easy3ddll name 'E3DGetSpecular';
  function E3DGetAmbient; external Easy3ddll name 'E3DGetAmbient';
  function E3DGetAlpha; external Easy3ddll name 'E3DGetAlpha';
  function E3DSaveSigFile; external Easy3ddll name 'E3DSaveSigFile';
  function E3DSetMipMapParams; external Easy3ddll name 'E3DSetMipMapParams';
  function E3DPickVert; external Easy3ddll name 'E3DPickVert';
  function E3DGetCullingFlag; external Easy3ddll name 'E3DGetCullingFlag';
  function E3DGetOrgVertNo; external Easy3ddll name 'E3DGetOrgVertNo';
  function E3DLoadIM2File; external Easy3ddll name 'E3DLoadIM2File';
  function E3DSaveIM2File; external Easy3ddll name 'E3DSaveIM2File';
  function E3DChkIM2Status; external Easy3ddll name 'E3DChkIM2Status';
  function E3DGetScreenPos2; external Easy3ddll name 'E3DGetScreenPos2';

end.
